local OiLvlPlayer = {
  frame = CreateFrame("Frame"),
  set = 0  
}

local Items = {
  CharacterHeadSlot = 1,
  CharacterNeckSlot = 2,
  CharacterShoulderSlot = 3,
  CharacterBackSlot = 15,
  CharacterChestSlot = 5,
  CharacterWristSlot = 9,
  CharacterHandsSlot = 10,
  CharacterWaistSlot = 6,
  CharacterLegsSlot = 7,
  CharacterFeetSlot = 8,
  CharacterFinger0Slot = 11,
  CharacterFinger1Slot = 12,
  CharacterTrinket0Slot = 13,
  CharacterTrinket1Slot = 14,
  CharacterMainHandSlot = 16,
  CharacterSecondaryHandSlot = 17,
  CharacterRangedSlot = 18,
  CharacterAmmoSlot = 0
}

local enchantItem = {
	[0] = {0},
	[1] = {0},
	[2] = {0},
	[3] = {1},
	[5] = {1},
	[6] = {0},
	[7] = {1},
	[8] = {1},
	[9] = {1},
	[10] = {1},
	[11] = {0},
	[12] = {0},
	[13] = {0},
	[14] = {0},
	[15] = {1},
	[16] = {1},
	[17] = {1},
	[18] = {1},
}

 local quality_color = {
	[0] = {127.5/255, 127.5/255, 127.5/255}, -- Poor (Gray)
	[1] = { 255/255, 255/255, 255/255}, -- Common (White)
	[2] = { 0/255, 255/255, 0/255}, -- Uncommon (Green)
	[3] = { 25/255, 127.5/255, 255/255}, -- Rare (Blue)
	[4] = { 255/255, 127/255, 243/255}, -- Epic (Purple)
	[5] = { 255/255, 165.75/255, 0/255}, -- Legendary (Orange)
	[6] = { 255/255, 204/255, 0/255}, -- Artifact (Light Gold)
	[7] = { 255/255, 255/255, 0/255}, -- Heirloom (Light Gold)
}
 
function OiLvlPlayer_Update()
  local tCount = 0;
  local tSlots = 0;
  local uLvl = 0;

  for Key, Value in pairs(Items) do
    local ItemLink = GetInventoryItemLink("player", Value)
    local Slot = getglobal(Key.."Stock");
    
    if Slot then
      Slot:Hide();
      if ItemLink then
        local _, _, quality, ItemLevel, _, _, _, StackCount = GetItemInfo(ItemLink)
  local cLvl, mLvl = OiLvlPlayer_ItemUpgradeLevel(ItemLink)
  uLvl = 0;
		local _,enchant,_,_,_,_,_ = ItemLink:match("item:(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)");
		local missenchant = "";
		if enchantItem[Value][1] == 1 and enchant == "0" then	missenchant = "! "; end
        if StackCount == 1 then
          if cLvl == nil then cLvl = 0 end
          if mLvl == nil then mLvl = 0 end
      
          uLvl = cLvl * 4
    
          --if mLvl > 0 and mLvl == cLvl then uLvl = 8 end
          --if mLvl == 2 and cLvl == 1 then uLvl = 4 end
          
		tCount = tCount + ItemLevel + uLvl;
        tSlots = tSlots + 1;
		Slot:ClearAllPoints();
		Slot:SetPoint("CENTER",0,-10);		  
        Slot:SetText(missenchant..ItemLevel + uLvl);
        if missenchant == "" then 
			Slot:SetTextColor(quality_color[quality][1], quality_color[quality][2], quality_color[quality][3], 1); 
		else
			Slot:SetTextColor(1,0,0,1); 
		end
		Slot:SetShadowColor(1,1,1,1);
		Slot:Show();
        end
      end
    end
  end
end

local S_UPGRADE_LEVEL = "^" .. gsub(ITEM_UPGRADE_TOOLTIP_FORMAT, "%%d", "(%%d+)")

-- Create the tooltip:
local scantip = CreateFrame("GameTooltip", "OiLvlPlayer_Tooltip", nil, "GameTooltipTemplate")
scantip:SetOwner(UIParent, "ANCHOR_NONE")

function OiLvlPlayer_ItemUpgradeLevel(itemLink)
    -- Pass the item link to the tooltip:
    scantip:SetHyperlink(itemLink)

    -- Scan the tooltip:
    for i = 2, scantip:NumLines() do -- Line 1 is always the name so you can skip it.
      
        local text = _G["OiLvlPlayer_TooltipTextLeft"..i]:GetText()
        if text and text ~= "" then
            local currentUpgradeLevel, maxUpgradeLevel = strmatch(text, S_UPGRADE_LEVEL)
            if currentUpgradeLevel then
                return tonumber(currentUpgradeLevel), tonumber(maxUpgradeLevel)
            end
        end
    end
end


OiLvlPlayer.frame:SetScript("OnEvent", function(self, event, ...)
  if event == "PLAYER_ENTERING_WORLD" and OiLvlPlayer.set == 0 then
    OiLvlPlayer.set = 1;
    OiLvlPlayer.frame:RegisterEvent("UNIT_PORTRAIT_UPDATE");
    OiLvlPlayer.frame:RegisterEvent("ITEM_UPGRADE_MASTER_UPDATE");
  end
  
  if event == "UNIT_PORTRAIT_UPDATE" then
    OiLvlPlayer_Update();
  end
end)

OiLvlPlayer.frame:RegisterEvent("PLAYER_ENTERING_WORLD");